package core;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.conf.Configured;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.input.TextInputFormat;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;
import org.apache.hadoop.mapreduce.lib.output.TextOutputFormat;
import org.apache.hadoop.util.Tool;
import org.apache.hadoop.util.ToolRunner;

public class SoccerMatchExecutor extends Configured implements Tool {
	
	public static String OUT = "statistics_";
	public static String IN = "exchangers_info";
	
	public int run(String[] args) throws Exception {
		getConf().set("mapred.textoutputformat.separator", " ");//make the key -> value space separated (for iterations)
 
		if(args.length == 2) {
			IN = args[0];
			OUT = args[1];
		}
 
		String infile = IN;
		String outputfile = OUT + System.nanoTime();
 
		Configuration conf = getConf();
//		conf.set("mapred.job.tracker", "local");
//		conf.set("fs.default.name", "local");
		Job job = new Job(conf);
		job.setJarByClass(SoccerMatchExecutor.class);
		job.setJobName("SoccerMatchExecutor");
		job.setOutputKeyClass(Text.class);
		job.setOutputValueClass(Text.class);
		job.setMapperClass(MatchesMapper.class);
		job.setReducerClass(VolumeCounterPerCoefficient.class);
		job.setInputFormatClass(TextInputFormat.class);
		job.setOutputFormatClass(TextOutputFormat.class);

		FileInputFormat.addInputPath(job, new Path(infile));
		FileOutputFormat.setOutputPath(job, new Path(outputfile));
		
		return job.waitForCompletion(true) ? 0 : 1;
	}
 
	public static void main(String[] args) throws Exception {
		System.exit(ToolRunner.run(new SoccerMatchExecutor(), args));
	}

}
